package com.chinaitop.depot.supervise.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.depot.supervise.service.CcZyService;
import com.chinaitop.utils.ParameterUtil;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

/**
 * @auther mafy
 * @createtime 2017/11/11 0011
 * 仓储作业-仓储作业记录
 */
@RestController
@RequestMapping(value = "/ccZy")
@Api(description = "仓储作业-仓储作业记录")
public class CcZyController {

    @Resource
    private CcZyService ccZyService;

    /**
     * 查询仓储处作业记录
     * @param pageNum
     * @param pageSize
     * @param houseId
     * @param startDate
     * @param endDate
     * @return
     */
    @RequestMapping(value = "/list", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
    @ApiOperation(value="仓储处作业记录", notes = "查询仓储处作业记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", paramType = "query"),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", paramType = "query"),
            @ApiImplicitParam(name = "houseId", value = "仓房ID", paramType = "query"),
            @ApiImplicitParam(name = "startDate", value = "作业开始时间", paramType = "query"),
            @ApiImplicitParam(name = "endDate", value = "作业结束时间", paramType = "query")
    })
    public PageInfo<Map<String,Object>> getCcZyList(Integer pageNum, Integer pageSize,Integer houseId,String startDate,String endDate){

        Map<String,Object> map = new HashMap<>();

        if(ParameterUtil.isnotnull(houseId)){
            map.put("houseId",houseId);
        }
        if(ParameterUtil.isnotnull(startDate)){
            map.put("startTime",startDate);
        }
        if(ParameterUtil.isnotnull(endDate)){
            map.put("endTime",endDate);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String,Object>> list = ccZyService.getCcZyList(map);
        PageInfo<Map<String,Object>> pageInfo = new PageInfo<Map<String,Object>>(list);
        return pageInfo;
    }
    
    /**
     * 根据保管员编号查询所有作业记录
     * @param id
     * @return
     */
    @RequestMapping(value="/all", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
    @ApiOperation(value="仓储处作业记录", notes = "根据保管员编号查询所有作业记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "保管员编号", paramType = "query")
    })
    public List<Map<String, Object>> allList(Integer id) {
    	return ccZyService.queryAll(id);
    }
    
}
