package com.chinaitop.depot.supervise.service.impl;

import com.chinaitop.depot.supervise.mapper.DepotStyleMapper;
import com.chinaitop.depot.supervise.model.DepotStyle;
import com.chinaitop.depot.supervise.model.DepotStyleExample;
import com.chinaitop.depot.supervise.service.depotStyleService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
public class depotStyleServiceImpl implements depotStyleService {

    @Resource
    private DepotStyleMapper depotStyleMapper;

    @Override
    public List<Map<String,Object>> getCameraPoint(Map<String,Object> map) {
        return depotStyleMapper.selectByCameraPoint(map);
    }

    @Override
    public List<Map<String,Object>> getGrainsituation(Map<String,Object> map) {
        return depotStyleMapper.selectByGrainSituaiton(map);
    }

    /**
     * 获取仓储作业
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectWorkingForHouse(Map<String, Object> map) {
        return depotStyleMapper.selectWorkingForHouse(map);
    }
    /**
     * 获取储粮信息
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectLQForHouse(Map<String, Object> map) {
        return depotStyleMapper.selectLQForHouse(map);
    }


    /**
     * 获取正在进行通风的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectCLTask(Map<String, Object> map) {
        return depotStyleMapper.selectCLTask(map);
    }

    /**
     * 获取正在进行熏蒸的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectCLXZ(Map<String, Object> map) {
        return depotStyleMapper.selectCLXZ(map);
    }

    /**
     * 获取正在进行入库的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectRK(Map<String, Object> map) {
        return depotStyleMapper.selectRK(map);
    }

    /**
     * 获取正在进行出库的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectCK(Map<String, Object> map) {
        return depotStyleMapper.selectCK(map);
    }

    @Override
    public void addPoint(DepotStyle depotStyle) {
        depotStyleMapper.insert(depotStyle);
    }

    @Override
    public void deletePoint(DepotStyle style) {
        DepotStyleExample example = new DepotStyleExample();
        DepotStyleExample.Criteria criteria= example.createCriteria();
        criteria.andTypeEqualTo(style.getType());
        criteria.andIndexidEqualTo(style.getIndexid());
        depotStyleMapper.deleteByExample(example);
    }

    @Override
    public List<DepotStyle> selectPoint(DepotStyleExample example) {
        return depotStyleMapper.selectByExampleWithBLOBs(example);
    }

    @Override
    public List<Map<String,Object>> getHouseStatePointChart(Map<String,Object> map) {
        return depotStyleMapper.selectHouseState(map);
    }
}
