package com.chinaitop.utils;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

public class ParameterUtil {

    public static String getSysDateTime() {
        String temp_str = "";
        Date dt = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        temp_str = sdf.format(dt);
        System.out.println("获取当前时间" + temp_str);
        return temp_str;
    }

    public static String getDateYMDHMS(Date date) {
        String str = "";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        str = sdf.format(date);
        System.out.println("获取当前时间" + str);
        return str;
    }

    public static String getSysDate() {
        String temp_str = "";
        Date dt = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        temp_str = sdf.format(dt);
        return temp_str;
    }

    public static Date string2datetime(String dateTime) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = null;
        try {
            date = dateFormat.parse(dateTime);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date;
    }

    public static Date string2date(String dateTime) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date date = null;
        try {
            date = dateFormat.parse(dateTime);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date;
    }

    public static String date2string(Date date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String str = sdf.format(date);
        return str;
    }

    /**
     * 获取指定时间的时间戳
     *
     * @param datatime
     * @return
     */
    public static String getTimeStamp(String datatime) {
        long timeStamp = 0;
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            Date date = format.parse(datatime);
            timeStamp = date.getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return String.valueOf(timeStamp);
    }

    /*
     * 将时间戳转换为时间
     */
    public static String stampToDate(String s) {
        String res;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        long lt = new Long(s);
        Date date = new Date(lt);
        res = simpleDateFormat.format(date);
        return res;
    }

    //    public static void main(String[] args) {
//        System.out.println(stampToDate("1504689208643"));
//        System.out.println(getTimeStamp(getSysDateTime()));
//    }
    public static String getBHS(String BHS) {
        String[] str = BHS.split(",");
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < str.length; i++) {
            sb.append("'").append(str[i]).append("'").append(",");
        }
        String s = sb.toString();
        String t = s.substring(0, s.length() - 1);
        return t;
    }

    //判断字段值是为空 不为空返回ture
    public static boolean isnotnull(Object name) {
        return (null != name && !"".equals(name) && !"null".equals(name) && "null" != name);
    }

    //判断字段值是为空,为空返回ture
    public static boolean isnull(Object name) {
        return (null == name || "".equals(name) || "null".equals(name) || "null" == name);
    }

    //判断字段值是相等  相等返回ture
    public static boolean isequal(Object name, Object value) {
        if (name == value || name.equals(value)) {
            return true;
        }
        return false;
    }

    /**
     * 判断list和str数组是否全等
     *
     * @param list
     * @param str
     * @return
     */
    public static boolean isAllequal(List<String> list, String[] str) {
        boolean isbz = true;
        for (int z = 0; z < str.length; z++) {
            if (!isequal(list.get(z), str[z])) {
                isbz = false;
                break;
            }
        }
        return !isbz || !(str.length == list.size());
    }

    //判断字段值是否在某个集合里  在返回ture
    public static boolean isallequal(Object name, String[] value) {
        for (int i = 0; i < value.length; i++) {
            if (name == value[i] || name.equals(value[i])) {
                return true;
            }
        }
        return false;
    }

    /**
     * 从properties得到路径
     *
     * @param filePath
     * @return
     */
    public static Properties readProperties(String filePath) {
        Properties props = new Properties();
        try {
            InputStream in = new BufferedInputStream(ParameterUtil.class.getResourceAsStream(filePath));
            props.load(in);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return props;
    }

    public static String dellOneDay(String time) {
        String add = null;
        try {
            SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
            java.util.Date timeNow = df.parse(time);
            Calendar begin = Calendar.getInstance();
            begin.setTime(timeNow);
            begin.add(Calendar.DAY_OF_MONTH, -1);
            add = df.format(begin.getTime());
        } catch (Exception e) {
            e.printStackTrace();
        }
        return add;
    }

    //判断两个时间是否是同一周
    public static boolean isSameDate(Date d1, Date d2) {
        Calendar cal1 = Calendar.getInstance();
        Calendar cal2 = Calendar.getInstance();
        cal1.setTime(d1);
        cal2.setTime(d2);
        int subYear = cal1.get(Calendar.YEAR) - cal2.get(Calendar.YEAR);
        //subYear==0,说明是同一年
        if (subYear == 0) {
            if (cal1.get(Calendar.WEEK_OF_YEAR) == cal2.get(Calendar.WEEK_OF_YEAR))
                return true;
        }
        //例子:cal1是"2005-1-1"，cal2是"2004-12-25"
        //java对"2004-12-25"处理成第52周
        // "2004-12-26"它处理成了第1周，和"2005-1-1"相同了
        //大家可以查一下自己的日历
        //处理的比较好
        //说明:java的一月用"0"标识，那么12月用"11"
        else if (subYear == 1 && cal2.get(Calendar.MONTH) == 11) {
            if (cal1.get(Calendar.WEEK_OF_YEAR) == cal2.get(Calendar.WEEK_OF_YEAR))
                return true;
        }
        //例子:cal1是"2004-12-31"，cal2是"2005-1-1"
        else if (subYear == -1 && cal1.get(Calendar.MONTH) == 11) {
            if (cal1.get(Calendar.WEEK_OF_YEAR) == cal2.get(Calendar.WEEK_OF_YEAR))
                return true;
        }
        return false;
    }

    /**
     * List转换String
     *
     * @param list :需要转换的List
     * @return String转换后的字符串
     */
    public static String ListToString(List<?> list) {
        StringBuffer sb = new StringBuffer();
        if (list != null && list.size() > 0) {
            for (int i = 0; i < list.size(); i++) {
                if (list.get(i) == null || list.get(i) == "") {
                    continue;
                }
                // 如果值是list类型则调用自己
                if (list.get(i) instanceof List) {
                    sb.append(ListToString((List<?>) list.get(i)));
                    sb.append(",");
                } else if (list.get(i) instanceof Map) {
                    sb.append(MapToString((Map<?, ?>) list.get(i)));
                    sb.append(",");
                } else {
                    sb.append(list.get(i));
                    sb.append(",");
                }
            }
        }
        return "L" + sb.toString();
    }

    /**
     * Map转换String
     *
     * @param map :需要转换的Map
     * @return String转换后的字符串
     */
    public static String MapToString(Map<?, ?> map) {
        StringBuffer sb = new StringBuffer();
        // 遍历map
        for (Object obj : map.keySet()) {
            if (obj == null) {
                continue;
            }
            Object key = obj;
            Object value = map.get(key);
            if (value instanceof List<?>) {
                sb.append(key.toString() + "," + ListToString((List<?>) value));
                sb.append("|");
            } else if (value instanceof Map<?, ?>) {
                sb.append(key.toString() + "," + MapToString((Map<?, ?>) value));
                sb.append("|");
            } else {
                sb.append(key.toString() + "=" + value.toString());
                sb.append("|");
            }
        }
        return "M" + sb.toString();
    }

    /**
     * String转换List
     *
     * @param listText
     *            :需要转换的文本
     * @return List<?>
     */
    public static List<Map<String,Object>> StringToList(String listText) {
        if (listText == null || listText.equals("")) {
            return null;
        }
        listText = listText.substring(1);

        List<Map<String,Object>> list = new ArrayList<Map<String,Object>>();
        String[] text = listText.split("\\" + ",");
        String listStr = "";
        boolean flag = false;
        for (String str : text) {
            if (!str.equals("")) {
                if (str.charAt(0) == 'M') {
                    Map<String,Object> map = StringToMap(str);
                    list.add(map);
                } else if (str.charAt(0) == 'L' || flag) {
                    flag = true;
                    listStr += str + ",";
                }
            }
        }
        return list;
    }

    /**
     * String转换Map
     *
     * @param mapText
     *            :需要转换的字符串
     * @return Map<?,?>
     */
    public static Map<String, Object> StringToMap(String mapText) {

        if (mapText == null || mapText.equals("")) {
            return null;
        }
        mapText = mapText.substring(1);

        Map<String, Object> map = new HashMap<String, Object>();
        String[] text = mapText.split("\\" + "|"); // 转换为数组
        for (String str : text) {
            String[] keyText = str.split("="); // 转换key与value的数组
            if (keyText.length < 1) {
                continue;
            }
            String key = keyText[0]; // key
            String value = keyText[1]; // value
            if (value.charAt(0) == 'M') {
                Map<?, ?> map1 = StringToMap(value);
                map.put(key, map1);
            } else if (value.charAt(0) == 'L') {
                List<?> list = StringToList(value);
                map.put(key, list);
            } else {
                map.put(key, value);
            }
        }
        return map;
    }
}
